package org.openapitools.v1_0.api;

import org.openapitools.v1_0.model.Notebook;
import org.openapitools.v1_0.model.Snapshot;
import org.openapitools.v1_0.model.UserInfo;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.context.request.NativeWebRequest;

import javax.validation.Valid;
import java.util.Iterator;
import java.util.Optional;

@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2018-07-25T15:13:08" +
        ".866Z[GMT]")

@Controller
@RequestMapping("${openapi.ePOSNotebook.base-path:/v1.0}")
public class NotebookApiController implements NotebookApi {

    private final NativeWebRequest request;

    @Autowired
    NotebookService notebookService;

    private Logger logger = LoggerFactory.getLogger(NotebookApiController.class);
    @Autowired
    public NotebookApiController(final NativeWebRequest request) {
        this.request = request;
    }

    @Value("${endpoint.notebook.restore.enabled}")
    private boolean endPointNotebookRestoreEnabled;

    /**
     * NOTE: if the interface was regenerated by swagger and you get a compiler
     * error about incompatible return type then you need to change
     * ResponseEntity<SomeClass> to ResponseEntity<?> in the interface
     * (NotebookApi.java) and not in this class.
     */
    @Override
    public ResponseEntity<?> storeSnapshot(@PathVariable("id") String id, @Valid @RequestBody Snapshot snapshot) {
        UserInfo userInfo = null;
        String authHeader = null;
        logger.debug("Received headers:");
        for (Iterator<String> it = request.getHeaderNames(); it.hasNext(); ) {
            String header = it.next();
            logger.debug("Header: "+header+" Value: "+request.getHeader(header).toString());
            if (header.toLowerCase().equals("userinfo")) {
                userInfo = new UserInfo(request.getHeader(header).toString());
            }
            if (header.toLowerCase().equals("authorization")) {
                authHeader = request.getHeader(header).toString();
            }
        }
        return notebookService.storeSnapshot(id, snapshot, authHeader, userInfo);
    }

    /**
     * NOTE: if the interface was regenerated by swagger and you get a compiler error
     * about incompatible return type then you need to change ResponseEntity<SomeClass>
     * to ResponseEntity<?> in the interface (NotebookApi.java) and not in this class.
     */
    @Override
    public ResponseEntity<?> restoreNotebookLibs(
            @PathVariable("id") String id,
            @PathVariable("activityId") String activityId) {
        if (endPointNotebookRestoreEnabled) {
            UserInfo userInfo = null;
            logger.debug("Received headers:");
            for (Iterator<String> it = request.getHeaderNames(); it.hasNext(); ) {
                String header = it.next();
                logger.debug("Header: " + header + " Value: " + request.getHeader(header).toString());
                if (header.toLowerCase().equals("userinfo")) {
                    userInfo = new UserInfo(request.getHeader(header).toString());
                }
            }
            return notebookService.restoreNotebookLibs(id, activityId, userInfo);
        } else
            return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);
    }
    /**
     * NOTE: if the interface was regenerated by swagger and you get a compiler error
     * about incompatible return type then you need to change ResponseEntity<SomeClass>
     * to ResponseEntity<?> in the interface (NotebookApi.java) and not in this class.
     */
    @Override
    public ResponseEntity<?> updateNotebook(
            @PathVariable("id") String id,
            @Valid @RequestBody Notebook notebook) {
        return notebookService.updateNotebook(id,notebook);
    }

    /**
     * NOTE: if the interface was regenerated by swagger and you get a compiler error
     * about incompatible return type then you need to change ResponseEntity<SomeClass>
     * to ResponseEntity<?> in the interface (NotebookApi.java) and not in this class.
     */
    @Override
    public ResponseEntity<?> createNotebook(@Valid @RequestBody final Notebook notebook) {
        UserInfo userInfo = null;
        logger.debug("Received headers:");
        for (Iterator<String> it = request.getHeaderNames(); it.hasNext(); ) {
            String header = it.next();
            logger.debug("Header: "+header+" Value: "+request.getHeader(header).toString());
            if (header.toLowerCase().equals("userinfo")) {
                userInfo = new UserInfo(request.getHeader(header).toString());
            }
        }
        if (null != userInfo) return notebookService.createNotebook(notebook, userInfo);
        else return notebookService.createNotebook(notebook);
    }

    /**
     * NOTE: if the interface was regenerated by swagger and you get a compiler error
     * about incompatible return type then you need to change ResponseEntity<SomeClass>
     * to ResponseEntity<?> in the interface (NotebookApi.java) and not in this class.
     */
    @Override
    public ResponseEntity<?> getNotebook(@PathVariable("id") String id) {
        return notebookService.getNotebookById(id);
    }

    /**
     * NOTE: if the interface was regenerated by swagger and you get a compiler error
     * about incompatible return type then you need to change ResponseEntity<SomeClass>
     * to ResponseEntity<?> in the interface (NotebookApi.java) and not in this class.
     */
    @Override
    public ResponseEntity<?> deleteNotebook(@PathVariable("id") String id) {
        return notebookService.deleteNotebook(id);
    }

    @Override
    public Optional<NativeWebRequest> getRequest() {
        return Optional.ofNullable(request);
    }
}
